      SUBROUTINE YLM(V,LOMAX,Y)                                         
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Y(49)                                                     
      DIMENSION V(3),P(8,8)                                             
      DATA ZERO/0.00/,SNULL/1.E-10/,ONE/1.00/,FPI/12.566370600/         
C.....CALCULATE SINES AND COSINES OF THE POLAR ANGLES OF THE VECTOR V.  
      FPI=4.*ACOS(-1.D0)                                                  
      XY=V(1)**2+V(2)**2                                                
      XYZ=XY+V(3)**2                                                    
      IF (XY.GT.SNULL)  GO TO 6                                         
      CTH=ONE                                                           
      IF (V(3).LT.ZERO)  CTH=-CTH                                       
      STH=ZERO                                                          
      CFI=ONE                                                           
      SFI=ZERO                                                          
      GO TO 7                                                           
  6   XY=SQRT(XY)                                                       
      XYZ=SQRT(XYZ)                                                     
      CTH=V(3)/XYZ                                                      
      STH=XY/XYZ                                                        
      CFI=V(1)/XY                                                       
      SFI=V(2)/XY                                                       
  7   RF=ONE/SQRT(FPI)                                                  
      YR=RF                                                             
      Y(1)=YR                                                           
      I=1                                                               
      P(1,1)=ONE                                                        
      P(2,1)=CTH                                                        
      C2L=CTH                                                           
      TCTH=CTH+CTH                                                      
      L1=2                                                              
      L=1                                                               
  5   M=1                                                               
      I=I+L                                                             
      IDWN=I+2                                                          
      M1=2                                                              
      L2=L                                                              
      L=L1                                                              
      CMFI=ONE                                                          
      SMFI=ZERO                                                         
      L1=L+1                                                            
      LM=L2                                                             
      LM2=L                                                             
      CD=ONE                                                            
      C2L=C2L+TCTH                                                      
      SGNM=ONE                                                          
C.....RECURSE UPWARD IN L.                                              
   42 P(L1,M)=(C2L*P(L,M)-LM*P(L2,M))/LM2                               
   44 C1L=(LM+1)*CTH                                                    
      P(L,M1)=ZERO                                                      
C.....RECURSE UPWARD IN M.                                              
      IF (ABS(STH).LT.SNULL)  GO TO 3                                   
      P(L,M1)=(C1L*P(L,M)-LM2*P(L1,M))/STH                              
  3   I=I+1                                                             
      IDWN=IDWN-1                                                       
    9 CSR=SQRT((2*L-ONE)/(FPI*CD))                                      
      CYP=SGNM*CSR*P(L,M)                                               
      YR=CYP*CMFI                                                       
      YI=CYP*SMFI                                                       
      Y(I)=DCMPLX(YR,YI)                                                 
      IF(IDWN.NE.I) Y(IDWN)=SGNM*DCMPLX(YR,-YI)                          
      CN=CMFI                                                           
      CMFI=CN*CFI-SFI*SMFI                                              
      SMFI=SFI*CN+SMFI*CFI                                              
      M=M1                                                              
      M1=M+1                                                            
      LM2=LM2-1                                                         
      LM=LM+1                                                           
      CD=CD*LM*LM2                                                      
      SGNM=-SGNM                                                        
      IF (M-L)  42,3,12                                                 
  12  IF (L.LE.LOMAX)  GOTO 5                                           
      RETURN                                                            
      END                                                               
